# Release Notes

## Untagged

### User Supplied Secret - Breaking change!

*Nota bene* From commit 99efb78ed8ba69799045cff6c42c4a71bffdb703 the
computed CDI secret is also taking the User Supplied Secret into
account *even if the USS is not supplied*! This means if you start
using firmware from this commit and onwards your CDI and with it the
private key of the signerapp will change even if you haven't changed
the app in any way.

## engineering-release-1

### Hardware

#### Limitations

- The entropy generated by the TRNG has not yet been thoroughly tested, and the generator has not been adjusted to generate good, unbiased randomness. Any application that wants to use the entropy source SHOULD NOT use the output directly, but only as seed to a Digital Random Bit Generator (DRBG), such as Hash_DRBG.

- The UART is currently running at 38400 bps. Future releases will increase the bitrate when communication at higher bitrates has been verified as stable and error free.

- The internal clock frequency is currently limited to 12 MHz. Future releases will increase the clock frequency to provide improved performance.

- The functionality in the firmware is currently not exposed to the applications via a stable name space, API. Future releases will provide access to FW functions such as the BLAKE2s hash function.

- The timer currently does not include a timeout interrupt. Applications using the timer must check the status in order to detect a timeout event.

- The timer currently does not provide a set of typical settings. Applications using the timer must set timer and prescaler as needed to get the desired time given the current clock speed.
